package net.varek.rs2d;

import java.net.InetSocketAddress;
import java.util.Timer;
import org.apache.mina.common.IoAcceptor;
import org.apache.mina.integration.jmx.IoServiceManager;
import org.apache.mina.transport.socket.nio.SocketAcceptor;
import org.apache.mina.transport.socket.nio.SocketAcceptorConfig;
import net.varek.rs2d.net.ConnectionThrottleFilter;

/**
 * The entry point for RSC server.
 */
public class Server {
	/**
	 * The game engine
	 */
	private GameEngine engine;
	private Timer t;
	private IoAcceptor acceptor;
	private IoServiceManager serviceManager;
	private ConnectionHandler connectionHandler;
	private ConnectionThrottleFilter throttleFilter;
	
	public void start(int port) throws Exception {
		engine = new GameEngine();
		acceptor = new SocketAcceptor();
		connectionHandler = new ConnectionHandler(engine);
		Server.newThread(engine, "GameEngine");
		SocketAcceptorConfig sac = new SocketAcceptorConfig();
		sac.getSessionConfig().setTcpNoDelay(false);
		sac.setReuseAddress(true);
		sac.setBacklog(100);
		//serviceManager = new IoServiceManager( acceptor );
		//serviceManager.startCollectingStats(5000);
		//final SessionLoggingFilter logFilter = new SessionLoggingFilter();
		//sac.getFilterChain().addFirst("loggingFilter", logFilter);
		throttleFilter = new ConnectionThrottleFilter(2000);
		sac.getFilterChain().addFirst("throttleFilter", throttleFilter);
		acceptor.bind(new InetSocketAddress(port), connectionHandler, sac);
	}
	
	public static void newThread(Runnable r, String name) {
		Thread t = new Thread(group, r, name);
		t.start();
	}
	
	public IoServiceManager getServiceManager() {
		return serviceManager;
	}
	
	public ConnectionThrottleFilter getThrottleFilter() { return throttleFilter; }
	
	public void unbindPorts() throws Exception {
		Thread.sleep(200);
		acceptor.unbindAll();
		Thread.sleep(300);
	}
	
	public static void refresh() throws Exception {
		serverInst = new Server();
	}
	
	public static Server getServer() { return serverInst; }
	
	private static Server serverInst;
	private static ThreadGroup group;
}
